# -*- coding=UTF-8 -*-
# Code generated by auto-derby-plugin-generator
# URL: https://natescarlet.github.io/auto-derby-plugin-generator/#/plugins/race
# Date: 2021/8/11 下午11:19:13

import auto_derby
from auto_derby import single_mode


from typing import Text, Dict

_ACTION_NONE = 0
_ACTION_BAN = 1
_ACTION_LESS = 2
_ACTION_MORE = 3
_ACTION_PICK = 4

_DEFAULT_ACTION = _ACTION_NONE

_RULES: Dict[Text, Dict[int, int]] = {}


def _define_rule(turn: int, name: Text, action: int):
    _RULES.setdefault(name, {})[turn] = action


_define_rule(36, "ジャパンダートダービー", _ACTION_MORE)
_define_rule(44, "JBCクラシック", _ACTION_MORE)
_define_rule(44, "JBCスプリント", _ACTION_MORE)
_define_rule(44, "JBCレディスクラシック", _ACTION_MORE)
_define_rule(46, "チャンピオンズカップ", _ACTION_MORE)
_define_rule(47, "東京大賞典", _ACTION_MORE)
_define_rule(51, "フェブラリーステークス", _ACTION_MORE)
_define_rule(68, "JBCクラシック", _ACTION_MORE)
_define_rule(59, "帝王賞", _ACTION_MORE)
_define_rule(68, "JBCスプリント", _ACTION_MORE)
_define_rule(68, "JBCレディスクラシック", _ACTION_MORE)
_define_rule(70, "チャンピオンズカップ", _ACTION_MORE)
_define_rule(71, "東京大賞典", _ACTION_MORE)
_define_rule(18, "プラタナス賞", _ACTION_MORE)
_define_rule(19, "なでしこ賞", _ACTION_MORE)
_define_rule(20, "オキザリス賞", _ACTION_MORE)
_define_rule(22, "寒椿賞", _ACTION_PICK)
_define_rule(21, "カトレア賞", _ACTION_PICK)

# 小倉
_define_rule(38, "阿蘇ステークス", _ACTION_MORE)
# 北海道
_define_rule(62, "エルムステークス", _ACTION_PICK)


class Plugin(auto_derby.Plugin):
    def install(self) -> None:
        class Race(auto_derby.config.single_mode_race_class):
            def score(self, ctx: single_mode.Context) -> float:
                ret = super().score(ctx)
                action = _RULES.get(self.name, {}).get(
                    ctx.turn_count(), _DEFAULT_ACTION
                )
                if action == _ACTION_BAN:
                    ret = 0
                elif action == _ACTION_LESS:
                    ret -= 5
                elif action == _ACTION_MORE:
                    ret += 5
                elif action == _ACTION_PICK:
                    ret += 100
                return ret

        auto_derby.config.single_mode_race_class = Race


auto_derby.plugin.register(__name__, Plugin())
